package fr.inra.moulon.svgutils.svggelimage;

import org.w3c.dom.DOMException;
import org.w3c.dom.Element;

import fr.inra.moulon.svgutils.SvgGraphics;

public class SvgSpotSymbol {

	private Element symbol;
	private String className;
	private SvgGelImage svgGelImage;

	public SvgSpotSymbol(SvgGelImage svg_gelImage, String symbolId)
			throws DOMException, Exception {
		this.svgGelImage = svg_gelImage;
		/*
		 * <symbol id="MySymbol" viewBox="0 0 20 20"> <desc>MySymbol - four
		 * rectangles in a grid</desc> <rect x="1" y="1" width="8" height="8"/>
		 * <rect x="11" y="1" width="8" height="8"/> <rect x="1" y="11"
		 * width="8" height="8"/> <rect x="11" y="11" width="8" height="8"/>
		 * </symbol>
		 */
		symbol = svgGelImage.getSvgGraphic().symbol(symbolId);
		className = symbolId;
	}
	public String getClassName () {
		return className;
	}
	public String getId() {
		return symbol.getAttributeNS(null, "id");
	}

	public Element getElement() {
		return symbol;
	}
	
	public void setClassName(String className) throws Exception {
		if (className != null) {
			this.className = className;
			this.symbol.setAttributeNS(null, "class", className);
		}
	}

	public void setCss(String css) throws Exception {
		if (css == null) {
			css = "fill:none;stroke-width:"
					+ 2
					+ "px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1";
		}

		this.svgGelImage.getSvgGraphic().setCssClass("#" + this.getId() + " *",
				css);
	}

	public void drawCross(Float width) throws Exception {
		if (width == null) {
			width = (float) 6;
		}
		// draw a cross in a 100/100 square (0->10), the center must be at 50/50
		float half = width / 2;
		SvgGraphics.svgLine(this.svgGelImage.getSvgGraphic().getDocument(),
				symbol, 50, 50 - half, 50, 50 + half, null);
		SvgGraphics.svgLine(this.svgGelImage.getSvgGraphic().getDocument(),
				symbol, 50 - half, 50, 50 + half, 50, null);
	}

	public void drawCircle(Float width) throws Exception {
		if (width == null) {
			width = (float) 10;
		}
		// draw a cross in a 100/100 square (0->10), the center must be at 50/50
		// <circle cx="100" cy="50" r="40"
		SvgGraphics.svgCircle(this.svgGelImage.getSvgGraphic().getDocument(),
				symbol, 50, 50, width, null);
		SvgGraphics.svgCircle(this.svgGelImage.getSvgGraphic().getDocument(),
				symbol, 50, 50, width, null);
	}

}
