package fr.inra.moulon.svgutils.svgprotcover;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;

import org.w3c.dom.*;

import fr.inra.moulon.svgutils.SvgGraphics;
import fr.inra.moulon.svgutils.SvgGroup;

public class DocSvgProtCover implements fr.inra.moulon.svgutils.SvgCommon {
	private SvgGraphics svg_graphic;

	protected Float graphWidth = null;
	protected Float graphHeight = null;

	protected SvgGroup mainGraph;
	protected SvgProtein svgProtein;

	public DocSvgProtCover() throws Exception {

		svgProtein = null;
	}

	public void addPeptidePosition(int beginPos, int endPos, URL peptideUrl) throws Exception {
		if (svgProtein == null) {
			throw new Exception(
					"Please setProteinSequence before adding peptide position");
		}
		svgProtein.addPeptidePosition(beginPos, endPos, peptideUrl);
	}

	public void setProteinSequence(String protSequence) {
		svgProtein = new SvgProtein(protSequence);
	}

	public Document getDocument() throws Exception {
		this.draw();
		return this.svg_graphic.getDocument();
	}

	public SvgGraphics getSvgGraphic() throws Exception {
		return this.svg_graphic;
	}

	public void toOutputStream(java.io.OutputStream out) throws Exception {
		this.draw();
		svg_graphic.toOutputStream(out);

	}

	public void toFile(File filename) throws Exception {

		try {
			// Open an output stream
			FileOutputStream fstream = new FileOutputStream(
					filename.getAbsolutePath());
			// BufferedWriter out = new BufferedWriter(fstream);
			// Print a line of text
			this.toOutputStream(fstream);

			// Close our output stream
			fstream.close();
		}
		// Catches any error conditions
		catch (IOException e) {
			System.err.println("Unable to write to file");
			System.exit(-1);
		}

	}

	private void draw() throws Exception {
	}
}
