package fr.inra.moulon.xhtmlutils;

import org.w3c.dom.*;

public class XhtmlElementBase implements org.w3c.dom.Element, org.w3c.dom.Node {

	protected XhtmlDocument document;
	protected Element element;
	
	public XhtmlDocument getXhtmlDocument() {
		return document;
	}

	public void setId(String id) {
		element.setAttributeNS(null, "id", id);
	}

	public void setCssClass(String className) {
		element.setAttributeNS(null, "class", className);
	}

	public Element getElement() {
		return this.element;
	}
	public XhtmlElementBase appendChild(XhtmlElementBase newChild) throws DOMException {
		element.appendChild(newChild.getElement());
		return this;
	}


	public XhtmlElementBase(XhtmlDocument document, String elementName) {
		this.document = document;
		element = document.getDocument().createElementNS(XhtmlDocument.xhtmlNS,
				elementName);
	}

	public Node appendChild(Node newChild) throws DOMException {
		return element.appendChild(newChild);
	}

	public Node cloneNode(boolean deep) {
		return element.cloneNode(deep);
	}

	public short compareDocumentPosition(Node other) throws DOMException {
		return element.compareDocumentPosition(other);
	}

	public NamedNodeMap getAttributes() {
		return element.getAttributes();
	}

	public String getBaseURI() {
		return element.getBaseURI();
	}

	public NodeList getChildNodes() {
		return element.getChildNodes();
	}

	public Object getFeature(String feature, String version) {
		return element.getFeature(feature, version);
	}

	public Node getFirstChild() {
		return element.getFirstChild();
	}

	public Node getLastChild() {
		return element.getLastChild();
	}

	public String getLocalName() {
		return element.getLocalName();
	}

	public String getNamespaceURI() {
		return element.getNamespaceURI();
	}

	public Node getNextSibling() {
		return element.getNextSibling();
	}

	public String getNodeName() {
		return element.getNodeName();
	}

	public short getNodeType() {
		return element.getNodeType();
	}

	public String getNodeValue() throws DOMException {
		return element.getNodeValue();
	}

	public Document getOwnerDocument() {
		return element.getOwnerDocument();
	}

	public Node getParentNode() {
		return element.getParentNode();
	}

	public String getPrefix() {
		return element.getPrefix();
	}

	public Node getPreviousSibling() {
		return element.getPreviousSibling();
	}

	public String getTextContent() throws DOMException {
		return element.getTextContent();
	}

	public Object getUserData(String key) {
		return element.getUserData(key);
	}

	public boolean hasAttributes() {
		return element.hasAttributes();
	}

	public boolean hasChildNodes() {
		return element.hasChildNodes();
	}

	public Node insertBefore(Node newChild, Node refChild) throws DOMException {
		return element.insertBefore(newChild, refChild);
	}

	public boolean isDefaultNamespace(String namespaceURI) {
		return element.isDefaultNamespace(namespaceURI);
	}

	public boolean isEqualNode(Node arg) {
		return element.isEqualNode(arg);
	}

	public boolean isSameNode(Node other) {
		return element.isSameNode(other);
	}

	public boolean isSupported(String feature, String version) {
		return element.isSupported(feature, version);
	}

	public String lookupNamespaceURI(String prefix) {
		return element.lookupNamespaceURI(prefix);
	}

	public String lookupPrefix(String namespaceURI) {
		return element.lookupPrefix(namespaceURI);
	}

	public void normalize() {
		element.normalize();
	}

	public Node removeChild(Node oldChild) throws DOMException {
		return element.removeChild(oldChild);
	}

	public Node replaceChild(Node newChild, Node oldChild) throws DOMException {
		return element.replaceChild(newChild, oldChild);
	}

	public void setNodeValue(String nodeValue) throws DOMException {
		element.setNodeValue(nodeValue);
	}

	public void setPrefix(String prefix) throws DOMException {
		element.setPrefix(prefix);
	}

	public void setTextContent(String textContent) throws DOMException {
		if (textContent != null) {
		element.setTextContent(textContent);
		}
	}

	public Object setUserData(String key, Object data, UserDataHandler handler) {
		return element.setUserData(key, data, handler);
	}

	public String getAttribute(String name) {
		return element.getAttribute(name);
	}

	public String getAttributeNS(String namespaceURI, String localName)
			throws DOMException {
		return element.getAttributeNS(namespaceURI, localName);
	}

	public Attr getAttributeNode(String name) {
		return element.getAttributeNode(name);
	}

	public Attr getAttributeNodeNS(String namespaceURI, String localName)
			throws DOMException {
		return element.getAttributeNodeNS(namespaceURI, localName);
	}

	public NodeList getElementsByTagName(String name) {
		return element.getElementsByTagName(name);
	}

	public NodeList getElementsByTagNameNS(String namespaceURI, String localName)
			throws DOMException {
		return element.getElementsByTagNameNS(namespaceURI, localName);
	}

	public TypeInfo getSchemaTypeInfo() {
		return element.getSchemaTypeInfo();
	}

	public String getTagName() {
		return element.getTagName();
	}

	public boolean hasAttribute(String name) {
		return element.hasAttribute(name);
	}

	public boolean hasAttributeNS(String namespaceURI, String localName)
			throws DOMException {
		return element.hasAttributeNS(namespaceURI, localName);
	}

	public void removeAttribute(String name) throws DOMException {

		element.removeAttribute(name);
	}

	public void removeAttributeNS(String namespaceURI, String localName)
			throws DOMException {
		element.removeAttributeNS(namespaceURI, localName);
	}

	public Attr removeAttributeNode(Attr oldAttr) throws DOMException {
		return element.removeAttributeNode(oldAttr);
	}

	public void setAttribute(String name, String value) throws DOMException {
		element.setAttribute(name, value);
	}

	public void setAttributeNS(String namespaceURI, String qualifiedName,
			String value) throws DOMException {
		element.setAttributeNS(namespaceURI, qualifiedName, value);
	}

	public Attr setAttributeNode(Attr newAttr) throws DOMException {
		return element.setAttributeNode(newAttr);
	}

	public Attr setAttributeNodeNS(Attr newAttr) throws DOMException {
		return element.setAttributeNodeNS(newAttr);
	}

	public void setIdAttribute(String name, boolean isId) throws DOMException {
		element.setIdAttribute(name, isId);
	}

	public void setIdAttributeNS(String namespaceURI, String localName,
			boolean isId) throws DOMException {
		element.setIdAttributeNS(namespaceURI, localName, isId);
	}

	public void setIdAttributeNode(Attr idAttr, boolean isId)
			throws DOMException {
		element.setIdAttributeNode(idAttr, isId);
	}

}// end class SvgGraphics

