package fr.inra.moulon.xhtmlutils.xhtmltable;

import java.util.ArrayList;

import org.w3c.dom.Element;

import fr.inra.moulon.xhtmlutils.XhtmlDocument;
import fr.inra.moulon.xhtmlutils.XhtmlElementBase;

public class XhtmlTable extends XhtmlElementBase {

	private Element caption;
	private Element thead = null;
	private Element tbody = null;
	private Element currentTableRow = null;

	protected Element newTr() {
		return (document.getDocument().createElementNS(XhtmlDocument.xhtmlNS,
				"tr"));
	}

	protected Element newTh() {
		return (document.getDocument().createElementNS(XhtmlDocument.xhtmlNS,
				"th"));
	}

	protected XhtmlTableCell newTd() {
		return (new XhtmlTableCell(this));
	}

	public XhtmlTable(XhtmlDocument document) {
		super(document, "table");
		caption = document.getDocument().createElementNS(XhtmlDocument.xhtmlNS,
				"caption");
		this.element.appendChild(caption);
		thead = document.getDocument().createElementNS(XhtmlDocument.xhtmlNS,
				"thead");
		this.element.appendChild(thead);
		tbody = document.getDocument().createElementNS(XhtmlDocument.xhtmlNS,
				"tbody");
		this.element.appendChild(tbody);
		document.getCurrentNode().appendChild(this.getElement());
	}

	public void setCaption(String captionText) {
		// caption.setNodeValue(captionText);
		caption.setTextContent(captionText);
	}
	
	public void addHeaderLine(ArrayList<String> titleList) {

		Element tr = newTr();
		thead.appendChild(tr);
		for (String title : titleList) {
			XhtmlTableCell td = newTd();
			tr.appendChild(td.getElement());
			td.setTextContent(title);
		}
	}

	public void addHeaderLine() {
		currentTableRow = newTr();
		thead.appendChild(currentTableRow);
	}

	public void addTableRow() {
		currentTableRow = newTr();
		tbody.appendChild(currentTableRow);
	}

	public XhtmlTableCell addCell(String text) {
		if (currentTableRow == null) {
			this.addTableRow();
		}
		XhtmlTableCell td = newTd();
		currentTableRow.appendChild(td.getElement());
		td.setTextContent(text);
		return td;
	}

	public XhtmlDocument getXhtmlDocument() {
		return this.document;
	}

}
