package fr.inra.pappso.xtandempipeline.sax_parse;

import java.io.File;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import fr.inra.pappso.xtandempipeline.XtandemPipelineSession;
import fr.inra.pappso.xtandempipeline.class_msms.config;
import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.Modifs;
import fr.inra.pappso.xtandempipeline.class_msms.Peptide;
import fr.inra.pappso.xtandempipeline.class_msms.Protein;
import fr.inra.pappso.xtandempipeline.thread.DataType_Base;
import fr.inra.pappso.xtandempipeline.thread.process;

public class load_project extends org.xml.sax.helpers.DefaultHandler {
	private static final Logger logger = Logger.getLogger(load_project.class);

	private Protein prot_;

	private Peptide pep_;

	private Identification identification_;

//	private ArrayList<Identification> identifications;

	private Match match_;

	private String Last_element_;

	private String Start_element_;

	private String C_data;

	private DataType_Base datatype;

	private process pro;

	private String version;

	public load_project(config conf, process p) {
		super();
		//identifications = XtandemPipelineSession.getInstance().getIdentificationList();
		datatype = XtandemPipelineSession.getInstance().getDataTypeBase();
		this.pro = p;
	}

	public void error(SAXParseException e) throws SAXParseException {
		throw e;
	}

	public void startDocument() throws SAXException {
		identification_ = new Identification();
		prot_ = new Protein();
		pep_ = new Peptide();
		match_ = new Match();
		Last_element_ = "";
		Start_element_ = "";
		C_data = "";
		version = null;
		logger.info("Load project ...");
	}

	public void endDocument() throws SAXException {
		logger.info("Load project finish");
	}

	public void startElement(String namespaceURI, String simpleName,
			String qualifiedName, Attributes attrs) throws SAXException {

		if (pro.isStop()) {
			throw new SAXException("sax parser stopped");
		}

		Start_element_ = simpleName;
		if (Start_element_.equals(""))
			Start_element_ = qualifiedName;
		// System.out.println("Start= "+Start_element_);
		if (Start_element_.equals("xtandem_pipeline")) {
			this.version = attrs.getValue("version");
		}
		if (Start_element_.equals("information")) {
			datatype = datatype.getType(attrs.getValue("Data_Type"));
			XtandemPipelineSession.getInstance().setDataTypeBase(datatype);
			this.pro.set_max_progress(Integer.parseInt(attrs
					.getValue("match_number")));
		}
		if (Start_element_.equals("filter_params")) {
			datatype.getConf().set_peptide_evalue(
					Float.valueOf(attrs.getValue("pep_evalue")).floatValue());
			datatype.getConf().set_protein_evalue(
					Float.valueOf(attrs.getValue("prot_evalue")).floatValue());
			datatype.getConf().set_peptide_number(
					Integer.parseInt(attrs.getValue("pep_number")));
			datatype.getConf().set_protein_filter_to_complete(
					attrs.getValue("filter_to_all").equals("true"));
			datatype.getConf().set_database_filter(
					new File(attrs.getValue("database_filter")));
		}

		if (Start_element_.equals("identification")) {
			identification_ = new Identification();
		}
		if (Start_element_.equals("sample")) {
			identification_.addMsRun(attrs.getValue("value"));
		}
		if (Start_element_.equals("match")) {
			match_ = new Match();
			match_.setIsvalidate(attrs.getValue("validate").equals("true"));
		}

		if (Start_element_.equals("protein")) {
			prot_ = new Protein();
			// ajouter les elements de la prot
			prot_.set_description(attrs.getValue("description"));
			prot_.set_evalue(Float.valueOf(attrs.getValue("evalue"))
					.floatValue());
			prot_.setDatabase(identification_.getDatabaseSet().getInstance(
					attrs.getValue("URL")));
			prot_.set_peptide_number(Integer.parseInt(attrs
					.getValue("peptide_number")));
		}
		if (Start_element_.equals("protein_evalue")) {
			prot_.set_evalue(
					identification_.getMsRunSet().getInstance(
							attrs.getValue("sample")),
					Float.valueOf(attrs.getValue("evalue")).floatValue());
		}
		if (Start_element_.equals("peptide")) {
			pep_ = new Peptide();
			// ajouter les elements du peptides
			File sample_file = new File(attrs.getValue("sample_file"));
			pep_.set_sample_id(
					this.identification_.getMsRunSet().getInstance(
							sample_file.getName()), sample_file);
			pep_.set_scan(Integer.parseInt(attrs.getValue("scan_in_xtandem")));
			pep_.set_scan(Integer.parseInt(attrs.getValue("scan")));
			pep_.set_RT(attrs.getValue("RT"));
			pep_.set_mhplus_obser(Float.valueOf(attrs.getValue("mhplus_obser"))
					.floatValue());
			pep_.set_mhplus_theo(Float.valueOf(attrs.getValue("mhplus_theo"))
					.floatValue());
			pep_.set_deltamass(Float.valueOf(attrs.getValue("deltamass"))
					.floatValue());
			pep_.set_sequence(attrs.getValue("sequence"));
			pep_.set_pre(attrs.getValue("pre"));
			pep_.set_post(attrs.getValue("post"));
			pep_.set_start(Integer.parseInt(attrs.getValue("start")));
			pep_.set_stop(Integer.parseInt(attrs.getValue("stop")));
			pep_.set_charge(Integer.parseInt(attrs.getValue("charge")));
			pep_.set_evalue(Float.valueOf(attrs.getValue("evalue"))
					.floatValue());
			pep_.set_hypercorr(Float.valueOf(attrs.getValue("hypercorr"))
					.floatValue());
			pep_.setValidate(attrs.getValue("validate").equals("true"));
			// ajouter le peptide au match
			match_.add_peptide_match(pep_);
			identification_.add_peptide(pep_);
		}
		if (Start_element_.equals("modif")) {
			String aa = attrs.getValue("aa");
			float modvalue = Float.valueOf(attrs.getValue("modvalue"))
					.floatValue();
			int posi_in_prot = Integer.parseInt(attrs.getValue("posi_in_prot"));
			pep_.set_Modifs(aa, posi_in_prot, modvalue);
		}
		if (Start_element_.equals("modifs_mass")) {
			float modvalue = Float.valueOf(attrs.getValue("modvalue"))
					.floatValue();
			identification_.add_modifs_to_liste(new Modifs(modvalue));
		}

		C_data = "";
	}

	public void endElement(String namespaceURI, String simpleName,
			String qualifiedName) throws SAXException {
		Last_element_ = simpleName;
		if (Last_element_.equals(""))
			Last_element_ = qualifiedName;

		if (Last_element_.equals("protein")) {
			match_.set_protein_match(prot_);
		}
		if (Last_element_.equals("sequence")) {
			prot_.set_sequence(C_data);
		}
		if (Last_element_.equals("match")) {
			identification_.add_protein(prot_, match_);
			this.pro.add_current_progress();
		}
		if (Last_element_.equals("identification")) {
			XtandemPipelineSession.getInstance().getIdentificationList().add(identification_);
		}
		C_data = "";
	}

	public void characters(char buf[], int offset, int len) throws SAXException {
		C_data = C_data + new String(buf, offset, len);
		// System.out.println(C_data);
	}

	public String getVersion() {
		return version;
	}
}
