package fr.inra.pappso.xtandempipeline.sax_parse;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import org.xml.sax.InputSource;
import org.xml.sax.helpers.DefaultHandler;
import org.apache.log4j.Logger;
import org.apache.xerces.impl.io.MalformedByteSequenceException;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;

public class parse_file {
	private static final Logger logger = Logger.getLogger(parse_file.class);
	
	private DefaultHandler handler;

	private SAXParserFactory factory;

	private SAXParser saxParser;

	private File file_to_parse;

	public parse_file(DefaultHandler h, File f) throws Exception {
		// on recupere le handler et le fichier à parser
		this.handler = h;
		this.file_to_parse = f;
		logger.info("Parsing xml file : "+f.getName());
		if (!this.file_to_parse.exists())
			throw new MSMSException("The file "
					+ file_to_parse.getAbsolutePath()
					+ " doesn't exist : no parsing possible");
		this.factory = SAXParserFactory.newInstance();
		this.saxParser = factory.newSAXParser();

		try {
			InputStream inputStream = new FileInputStream(file_to_parse);
			InputSource is = new InputSource(inputStream);
			this.saxParser.parse(is, this.handler);
		} catch (MalformedByteSequenceException e) {
			try {
				logger.debug("Mauvais encodage");
				InputStream inputStream = new FileInputStream(file_to_parse);
				InputSource is = new InputSource(inputStream);
				is.setEncoding("ISO-8859-1");
				this.saxParser.parse(is, this.handler);
			} catch (Exception e2) {
				throw e2;
			}
		} catch (Exception e) {
			logger.error("Problems to parse xml file"+this.file_to_parse.getName());
			logger.error(e.getMessage());
			StackTraceElement[] f1 = e.getStackTrace();
			for(int i = 0;i<f1.length;i++){
				logger.error(f1[i]);
			}
			throw new MSMSException(this.file_to_parse.getName()
					+ " is not a valid xml file");
		}
	}

	public parse_file(DefaultHandler h, InputStream input) throws Exception {
		// on recupere le handler et le fichier à parser
		this.handler = h;
		this.factory = SAXParserFactory.newInstance();
		this.saxParser = factory.newSAXParser();

		try {
			this.saxParser.parse(input, this.handler);
		} catch (Exception e) {
			throw new MSMSException(this.file_to_parse.getName()
					+ " is not a valid xtandem xml result file\n" + e);
		}
	}

}
